<?php
/*
Plugin Name: BUN Kayan Yazı
Plugin URI: https://bun.com.tr
Description: BUN Danışmanlık tarafından ücretsiz olarak yayınlanan bu eklenti ile Sivas Belediyesi'nin sitesinden günlük vefat edenlerin bilgilerini çeker ve alt tarafta kayan yazı şeklinde gösterir. Kullanmak için [bun_kayan_yazi] kodunu sayfanıza ekleyin. Ayarlar Menüsünden BUN kayan yazı linkine giriş yaparak renk, yazı hızı gibi ayarları yapabilirsiniz.İletişim 0212 935 00 11
Version: 1.0
Author: Halis YILDIZ
Author URI: https://bun.com.tr
*/

// CSS ve JS stilini ekleyelim
function bun_kayan_yazi_enqueue_scripts() {
    wp_enqueue_style('bun-kayan-yazi-style', plugins_url('bun-kayan-yazi.css', __FILE__));
}
add_action('wp_enqueue_scripts', 'bun_kayan_yazi_enqueue_scripts');

// Kısa kod fonksiyonunu ekleyelim
function bun_kayan_yazi_getir() {
    $url = 'https://www.sivas.bel.tr/kategori/49/0/aramizdan-ayrilanlar.aspx';
    $response = wp_remote_get($url, array('sslverify' => false));

    if (is_wp_error($response)) {
        return 'Sayfayı yenileyin. Veri alınamadı.';
    }

    $body = wp_remote_retrieve_body($response);

    preg_match('/<a href="(https:\/\/www\.sivas\.bel\.tr\/icerik\/49\/\d+\/\d{8}-aramizdan-ayrilanlar\.aspx)" target="_self">/', $body, $matches);

    if (empty($matches[1])) {
        return 'Veri alınamadı.';
    }

    $duyuru_url = $matches[1];
    $duyuru_response = wp_remote_get($duyuru_url, array('sslverify' => false));

    if (is_wp_error($duyuru_response)) {
        return 'Veri alınamadı.';
    }

    $duyuru_body = wp_remote_retrieve_body($duyuru_response);

    preg_match_all('/<table[^>]*>(.*?)<\/table>/s', $duyuru_body, $tables);

    $bun_kayan_yazi_content = 'ARAMIZDAN AYRILANLAR : ';

    foreach ($tables[0] as $table) {
        preg_match('/ADI SOYADI:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $name_match);
        preg_match('/YAŞI:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $age_match);
        preg_match('/YER \/ VAKİT:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $place_time_match);
        preg_match('/DEFİN YERİ:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $burial_place_match);
        preg_match('/MAHALLE:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $neighborhood_match);

        // İsim alanını al ve kontrol et
        $name = !empty($name_match[1]) ? trim(strip_tags($name_match[1])) : '';

        // İsim alanında 3 veya daha az karakter varsa bu tabloyu atla
        if (strlen($name) <= 3) {
            continue;
        }

        $age = !empty($age_match[1]) ? trim(strip_tags($age_match[1])) : '-';
        $place_time = !empty($place_time_match[1]) ? trim(strip_tags($place_time_match[1])) : '-';
        $burial_place = !empty($burial_place_match[1]) ? trim(strip_tags($burial_place_match[1])) : '-';
        $neighborhood = !empty($neighborhood_match[1]) ? trim(strip_tags($neighborhood_match[1])) : '';

        $bun_kayan_yazi_content .= $neighborhood . ' ' . $name . ' ' . $age . ' yaşında hakkın rahmetine kavuşmuştur. Cenazesi ' . $place_time . ' de ' . $burial_place . 'ndan kaldırılacaktır. Merhum\'a Allah\'tan rahmet yakınlarına baş sağlığı dileriz. <img src=https://ceptesivas.com/ceptesivasicon.png width=15> ';
    }

    return '<div class="bun-kayan-yazi-content"><div class="bun-kayan-yazi-marquee"><div>' . $bun_kayan_yazi_content . '</div></div></div>';
}

// Kısa kod eklemesi
function bun_kayan_yazi_shortcode() {
    return bun_kayan_yazi_getir();
}
add_shortcode('bun_kayan_yazi', 'bun_kayan_yazi_shortcode');

// Yönetim paneli seçenekleri
function bun_kayan_yazi_menu() {
    add_options_page(
        'BUN Kayan Yazı Ayarları',
        'BUN Kayan Yazı',
        'manage_options',
        'bun-kayan-yazi',
        'bun_kayan_yazi_options_page'
    );
}
add_action('admin_menu', 'bun_kayan_yazi_menu');

function bun_kayan_yazi_options_page() {
    ?>
    <div class="wrap">
        <h1>BUN Kayan Yazı Ayarları</h1>
        <form method="post" action="options.php">
            <?php
            settings_fields('bun_kayan_yazi_options');
            do_settings_sections('bun-kayan-yazi');
            submit_button();
            ?>
        </form>
    </div>
    <?php
}

function bun_kayan_yazi_settings_init() {
    register_setting('bun_kayan_yazi_options', 'bun_kayan_yazi_settings');

    add_settings_section(
        'bun_kayan_yazi_section',
        'Genel Ayarlar',
        'bun_kayan_yazi_section_callback',
        'bun-kayan-yazi'
    );

    add_settings_field(
        'bun_kayan_yazi_background_color',
        'Arka Plan Rengi',
        'bun_kayan_yazi_background_color_render',
        'bun-kayan-yazi',
        'bun_kayan_yazi_section'
    );

    add_settings_field(
        'bun_kayan_yazi_text_color',
        'Yazı Rengi',
        'bun_kayan_yazi_text_color_render',
        'bun-kayan-yazi',
        'bun_kayan_yazi_section'
    );

    add_settings_field(
        'bun_kayan_yazi_font_size',
        'Yazı Boyutu',
        'bun_kayan_yazi_font_size_render',
        'bun-kayan-yazi',
        'bun_kayan_yazi_section'
    );

    add_settings_field(
        'bun_kayan_yazi_scroll_speed',
        'Kayma Hızı (saniye)',
        'bun_kayan_yazi_scroll_speed_render',
        'bun-kayan-yazi',
        'bun_kayan_yazi_section'
    );
}
add_action('admin_init', 'bun_kayan_yazi_settings_init');

function bun_kayan_yazi_section_callback() {
    echo 'Kayan yazı için ayarlarınızı buradan yapabilirsiniz.';
}

function bun_kayan_yazi_background_color_render() {
    $options = get_option('bun_kayan_yazi_settings');
    ?>
    <input type='text' name='bun_kayan_yazi_settings[bun_kayan_yazi_background_color]' value='<?php echo $options['bun_kayan_yazi_background_color']; ?>'>
    <?php
}

function bun_kayan_yazi_text_color_render() {
    $options = get_option('bun_kayan_yazi_settings');
    ?>
    <input type='text' name='bun_kayan_yazi_settings[bun_kayan_yazi_text_color]' value='<?php echo $options['bun_kayan_yazi_text_color']; ?>'>
    <?php
}

function bun_kayan_yazi_font_size_render() {
    $options = get_option('bun_kayan_yazi_settings');
    ?>
    <input type='text' name='bun_kayan_yazi_settings[bun_kayan_yazi_font_size]' value='<?php echo $options['bun_kayan_yazi_font_size']; ?>'>
    <?php
}

function bun_kayan_yazi_scroll_speed_render() {
    $options = get_option('bun_kayan_yazi_settings');
    ?>
    <input type='number' name='bun_kayan_yazi_settings[bun_kayan_yazi_scroll_speed]' value='<?php echo $options['bun_kayan_yazi_scroll_speed']; ?>'>
    <?php
}

// Stil ayarlarını ekle
function bun_kayan_yazi_customize_css() {
    $options = get_option('bun_kayan_yazi_settings');
    ?>
    <style>
        .bun-kayan-yazi-content {
            --background-color: <?php echo $options['bun_kayan_yazi_background_color']; ?>;
            --text-color: <?php echo $options['bun_kayan_yazi_text_color']; ?>;
            --font-size: <?php echo $options['bun_kayan_yazi_font_size']; ?>px;
            --scroll-speed: <?php echo $options['bun_kayan_yazi_scroll_speed']; ?>s;
        }
    </style>
    <?php
}
add_action('wp_head', 'bun_kayan_yazi_customize_css');

// Eklenti aktif olduğunda kayan yazıyı otomatik göster
function bun_kayan_yazi_display() {
    echo do_shortcode('[bun_kayan_yazi]');
}
add_action('wp_footer', 'bun_kayan_yazi_display');

// CSS dosyası
file_put_contents(plugin_dir_path(__FILE__) . 'bun-kayan-yazi.css', '
.bun-kayan-yazi-content {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    background-color: var(--background-color, #000);
    color: var(--text-color, #fff);
    font-size: var(--font-size, 16px);
    z-index: 9999;
    padding: 10px;
}

.bun-kayan-yazi-marquee {
    display: block;
    white-space: nowrap;
    overflow: hidden;
    box-sizing: border-box;
}

.bun-kayan-yazi-marquee:after {
    content: "";
    display: inline-block;
    width: 100%;
}

.bun-kayan-yazi-marquee > div {
    display: inline-block;
    padding-left: 100%;
    animation: marquee var(--scroll-speed, 20s) linear infinite;
}

@keyframes marquee {
    0% { transform: translate(0, 0); }
    100% { transform: translate(-100%, 0); }
}
');
?>
