<?php
/*
Plugin Name: Aramızdan Ayrılanlar
Plugin URI: https://bun.com.tr
Description: BUN Danışmanlık tarafından ücretsiz yayınlanan bu eklenti ile Sivas Belediyesi'nin sitesinden günlük vefat edenlerin bilgilerini sitenizde anlık gösterebilirsiniz. Kullanmak için [aramizdan_ayrilanlar] kodunu sayfanıza ekleyin.
Version: 1.6
Author: Halis YILDIZ
Author URI: https://bun.com.tr
*/

// CSS stilini ekleyelim
function aramizdan_ayrilanlar_scripts() {
    echo '<style>
        .aramizdan-ayrilanlar-content {
            margin: 20px 0;
            padding: 10px;
            border: 1px solid #ddd;
            background-color: #f9f9f9;
        }
        .aramizdan-ayrilanlar-entry {
            margin-bottom: 15px;
            padding: 10px;
            border: 1px solid #ccc;
            background-color: #fff;
        }
        .aramizdan-ayrilanlar-entry p {
            margin: 5px 0;
        }
        .aramizdan-ayrilanlar-entry strong {
            font-weight: bold;
        }
    </style>';
}
add_action('wp_head', 'aramizdan_ayrilanlar_scripts');

// Verileri çekme ve düzenleme
function aramizdan_ayrilanlar_getir() {
    $url = 'https://www.sivas.bel.tr/kategori/49/0/aramizdan-ayrilanlar.aspx';
    $response = wp_remote_get($url, array('sslverify' => false));

    if (is_wp_error($response)) {
        return 'Sayfayı yenileyin. Veri alınamadı.';
    }

    $body = wp_remote_retrieve_body($response);

    preg_match('/<a href="(https:\/\/www\.sivas\.bel\.tr\/icerik\/49\/\d+\/\d{8}-aramizdan-ayrilanlar\.aspx)" target="_self">/', $body, $matches);

    if (empty($matches[1])) {
        return 'Veri alınamadı.';
    }

    $duyuru_url = $matches[1];
    $duyuru_response = wp_remote_get($duyuru_url, array('sslverify' => false));

    if (is_wp_error($duyuru_response)) {
        return 'Veri alınamadı.';
    }

    $duyuru_body = wp_remote_retrieve_body($duyuru_response);

    preg_match_all('/<table[^>]*>(.*?)<\/table>/s', $duyuru_body, $tables);

    $aramizdan_ayrilanlar_content = '';

    foreach ($tables[0] as $table) {
        preg_match('/ADI SOYADI:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $name_match);
        $name = !empty($name_match[1]) ? trim(strip_tags($name_match[1])) : '';

        // İsim alanında 3 veya daha az karakter varsa bu tabloyu atla
        if (strlen($name) <= 3) {
            continue;
        }

        preg_match('/YAŞI:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $age_match);
        preg_match('/YER \/ VAKİT:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $place_time_match);
        preg_match('/DEFİN YERİ:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $burial_place_match);
        preg_match('/TAZİYE ADRESİ:<\/td>\s*<td[^>]*>\s*(.*?)\s*<\/td>/', $table, $condolence_match);

        $age = !empty($age_match[1]) ? trim(strip_tags($age_match[1])) : '';
        $place_time = !empty($place_time_match[1]) ? trim(strip_tags($place_time_match[1])) : '';
        $burial_place = !empty($burial_place_match[1]) ? trim(strip_tags($burial_place_match[1])) : '';
        $condolence = !empty($condolence_match[1]) ? trim(strip_tags($condolence_match[1])) : '';

        // İçeriğin geçerli olup olmadığını kontrol et
        $aramizdan_ayrilanlar_content .= '<div class="aramizdan-ayrilanlar-entry">';
        $aramizdan_ayrilanlar_content .= '<p><b>' . $name . ' </b>' . ($age ? '- ' . $age . ' yaşında vefat etmiştir.' : '') . '</p>';
        if ($condolence) {
            $aramizdan_ayrilanlar_content .= '<p><strong>Adresi:</strong> ' . $condolence . '</p>';
        }
        if ($place_time) {
            $aramizdan_ayrilanlar_content .= '<p>Cenazesi ' . $place_time . ' de defnedilecektir. Mekanı cennet olsun.</p>';
        }
        $aramizdan_ayrilanlar_content .= '</div>';
    }

    return '<div class="aramizdan-ayrilanlar-content">' . $aramizdan_ayrilanlar_content . '</div>Kaynak: Sivas Belediyesi Mezarlıklar Müdürlüğü';
}

// Kısa kod eklemesi
function aramizdan_ayrilanlar_shortcode() {
    return aramizdan_ayrilanlar_getir();
}
add_shortcode('aramizdan_ayrilanlar', 'aramizdan_ayrilanlar_shortcode');
